Index: trunk/kernel/syscalls/sys_read.c
===================================================================
--- trunk/kernel/syscalls/sys_read.c	(revision 690)
+++ trunk/kernel/syscalls/sys_read.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_read.c - Kernel function implementing the "read" system call.
+ * kern/sys_read.c - read bytes from an opened file
  * 
- * Author     Alain Greiner (2016,2017,2018,2019,2020)
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Copyright (c) UPMC Sorbonne Universites
+ * This file is part of ALMOS-kernel.
  *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,283 +17,40 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
-#include <hal_vmm.h>
-#include <hal_uspace.h>
-#include <hal_irqmask.h>
-#include <hal_special.h>
 #include <errno.h>
+#include <thread.h>
 #include <vfs.h>
-#include <vmm.h>
-#include <thread.h>
-#include <printk.h>
-#include <pipe.h>
-#include <process.h>
+#include <sys-vfs.h>
+#include <task.h>
 
+int sys_read (uint_t fd, void *buf, size_t count)
+{
+	struct ku_obj kub;
+	ssize_t err;
+	struct thread_s *this;
+	struct task_s *task;
+	struct vfs_file_s *file;
 
-extern uint32_t enter_sys_read;
-extern uint32_t enter_devfs_read;
-extern uint32_t enter_txt_read;
-extern uint32_t enter_chdev_cmd_read;
-extern uint32_t enter_chdev_server_read;
-extern uint32_t enter_tty_cmd_read;
-extern uint32_t enter_tty_isr_read;
-extern uint32_t exit_tty_isr_read;
-extern uint32_t exit_tty_cmd_read;
-extern uint32_t exit_chdev_server_read;
-extern uint32_t exit_chdev_cmd_read;
-extern uint32_t exit_txt_read;
-extern uint32_t exit_devfs_read;
-extern uint32_t exit_sys_read;
+	file = NULL;
+	this = current_thread;
+	task = current_task;
 
-
-/////////////////////////////////
-int sys_read( uint32_t   file_id,
-              void     * vaddr,
-              uint32_t   count )
-{
-    error_t       error;
-    vseg_t      * vseg;            // required for user space checking
-    xptr_t        file_xp;         // remote file extended pointer
-    vfs_file_t  * file_ptr;        // remote file local pointer
-    cxy_t         file_cxy;        // remote file cluster identifier
-    uint32_t      file_type;       // file type
-    uint32_t      file_offset;     // file offset 
-    uint32_t      file_attr;       // file attributes
-    vfs_inode_t * inode_ptr;       // local pointer on file inode
-    uint32_t      nbytes;          // number of bytes actually read
-    reg_t         save_sr;         // required to enable IRQs during syscall
-
-	thread_t    * this             = CURRENT_THREAD;
-	process_t   * process          = this->process;
-    xptr_t        process_owner_xp = process->owner_xp;
- 
-#if DEBUG_SYS_READ || DEBUG_SYSCALLS_ERROR || CONFIG_INSTRUMENTATION_SYSCALLS
-uint64_t     tm_start = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_READ
-if( DEBUG_SYS_READ < tm_start )
-printk("\n[%s] thread[%x,%x] enter / vaddr %x / count %d / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, vaddr, count, (uint32_t)tm_start );
-#endif
-
-#if (DEBUG_SYS_READ & 1)
-enter_sys_read = (uint32_t)tm_start;
-#endif
-
-    // check file_id argument
-	if( file_id >= CONFIG_PROCESS_FILE_MAX_NR )
+	if((fd >= CONFIG_TASK_FILE_MAX_NR) || (task_fd_lookup(task, fd, &file)))
 	{
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / illegal file descriptor index %d\n",
-__FUNCTION__ , process->pid, this->trdid, file_id );
-#endif
-		this->errno = EBADFD;
+		this->info.errno = EBADFD;
 		return -1;
 	}
 
-    // check user buffer in user space
-    error = vmm_get_vseg( process , (intptr_t)vaddr , &vseg );
-
-    if ( error )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / user buffer unmapped %x\n",
-__FUNCTION__ , process->pid, this->trdid, (intptr_t)vaddr );
-#endif
-		this->errno = EINVAL;
+	KU_SLICE_BUFF(kub, buf, count);
+	if((err = vfs_read(file, &kub)) < 0)
+	{
+		this->info.errno = -err;
+		printk(INFO, "INFO: sys_read: Error %d\n", this->info.errno);
 		return -1;
-    }
-
-    // get extended pointer on remote file descriptor
-    file_xp = process_fd_get_xptr_from_local( process , file_id );
-
-    if( file_xp == XPTR_NULL )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / undefined fd_id %d\n",
-__FUNCTION__, process->pid, this->trdid, file_id );
-#endif
-        this->errno = EBADFD;
-        return -1;
-    }
-
-    // get file descriptor cluster and local pointer
-    file_ptr = GET_PTR( file_xp );
-    file_cxy = GET_CXY( file_xp );
-
-    // get inode, file type, offset and attributes 
-    inode_ptr   = hal_remote_lpt( XPTR( file_cxy , &file_ptr->inode  ) );
-    file_type   = hal_remote_l32( XPTR( file_cxy , &file_ptr->type   ) );
-    file_offset = hal_remote_l32( XPTR( file_cxy , &file_ptr->offset ) );
-    file_attr   = hal_remote_l32( XPTR( file_cxy , &file_ptr->attr   ) );
-
-    // enable IRQs
-    hal_enable_irq( &save_sr );
-
-    // check file readable
-    if( (file_attr & FD_ATTR_READ_ENABLE) == 0 )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / file %d not readable\n",
-__FUNCTION__, process->pid, this->trdid, file_id );
-#endif
-        hal_restore_irq( save_sr );
-        this->errno = EBADFD;
-        return -1;
-    }
-
-    // action depend on file type:
-    if( file_type == FILE_TYPE_REG )                           // read from mapper 
-    {
-        // try to move count bytes from mapper
-        nbytes = vfs_user_move( true,   //  from mapper
-                                file_xp,
-                                vaddr, 
-                                count );
-    }
-    else if( file_type == FILE_TYPE_DEV )                      // read from TXT device
-    {
-        // get cluster and pointers on TXT_RX chdev 
-        xptr_t    chdev_xp  = chdev_from_file( file_xp );
-        cxy_t     chdev_cxy = GET_CXY( chdev_xp );
-        chdev_t * chdev_ptr = GET_PTR( chdev_xp );
-
-        volatile xptr_t    txt_owner_xp;    
-        uint32_t           iter = 0;
-
-        while( 1 )
-        {
-            // extended pointer on TXT owner process
-            txt_owner_xp  = hal_remote_l64( XPTR( chdev_cxy , 
-                                                  &chdev_ptr->ext.txt.owner_xp ) );
-            // wait for TXT_RX ownership
-            if ( process_owner_xp != txt_owner_xp )
-            {
-                if( (iter & 0xFFF) == 0 )
-                printk("\n[WARNING] in %s : thread[%x,%x] wait TXT_RX / cycle %d\n",
-                __FUNCTION__, process->pid, this->trdid, (uint32_t)hal_get_cycles() );
-
-                // deschedule without blocking
-                sched_yield( "wait TXT_RX ownership" );
-
-                iter++;
-            }
-            else
-            {
-                break;
-            }
-        }
-
-        // try to move count bytes from TXT device
-        nbytes = devfs_user_move( true,    // from device 
-                                  file_xp,
-                                  vaddr,
-                                  count );
-    }
-    else if( (file_type == FILE_TYPE_PIPE) ||
-             (file_type == FILE_TYPE_FIFO) )                  // read from pipe 
-    {
-        // try to move count bytes from pipe
-        nbytes = pipe_user_move( true,    // from pipe 
-                                 file_xp,
-                                 vaddr,
-                                 count );
-    }   
-    else                                                      // unsupported type
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / unsupported inode type %d\n",
-__FUNCTION__, vfs_inode_type_str( file_type ) );
-#endif
-		this->errno = EBADFD;
-        hal_restore_irq( save_sr );
-		return -1;
-    }
-
-    // check error
-    if( nbytes == 0xFFFFFFFF )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,‰x] cannot read data from file %d\n",
-__FUNCTION__, process->pid, this->trdid, file_id );
-#endif
-        this->errno = EIO;
-        hal_restore_irq( save_sr );
-        return -1;
-    }
-
-    // restore IRQs
-    hal_restore_irq( save_sr );
-
-    hal_fence();
-
-#if (DEBUG_SYS_READ || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_READ
-if( DEBUG_SYS_READ < tm_end )
-printk("\n[%s] thread[%x,%x] exit / cycle %d\n",
-__FUNCTION__ , process->pid, this->trdid, (uint32_t)tm_end );
-#endif
-
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_READ] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_READ] , 1 );
-#endif
-
-#if (DEBUG_SYS_READ & 1) 
-exit_sys_read = (uint32_t)tm_end;
-
-printk("\n***** timing to read one character *****\n"
-" - enter_sys_read          = %d / delta %d\n"
-" - enter_devfs_read        = %d / delta %d\n"
-" - enter_txt_read          = %d / delta %d\n"
-" - enter_chdev_cmd_read    = %d / delta %d\n"
-" - enter_chdev_server_read = %d / delta %d\n"
-" - enter_tty_cmd_read      = %d / delta %d\n"
-" - enter_tty_isr_read      = %d / delta %d\n"
-" - exit_tty_isr_read       = %d / delta %d\n"
-" - exit_tty_cmd_read       = %d / delta %d\n"
-" - exit_chdev_server_read  = %d / delta %d\n"
-" - exit_chdev_cmd_read     = %d / delta %d\n"
-" - exit_txt_read           = %d / delta %d\n"
-" - exit_devfs_read         = %d / delta %d\n"
-" - exit_sys_read           = %d / delta %d\n",
-enter_sys_read          , 0 ,
-enter_devfs_read        , enter_devfs_read        - enter_sys_read          ,
-enter_txt_read          , enter_txt_read          - enter_devfs_read        ,
-enter_chdev_cmd_read    , enter_chdev_cmd_read    - enter_txt_read          ,
-enter_chdev_server_read , enter_chdev_server_read - enter_chdev_cmd_read    ,
-enter_tty_cmd_read      , enter_tty_cmd_read      - enter_chdev_server_read ,
-enter_tty_isr_read      , enter_tty_isr_read      - enter_tty_cmd_read      ,
-exit_tty_isr_read       , exit_tty_isr_read       - enter_tty_isr_read      ,
-exit_tty_cmd_read       , exit_tty_cmd_read       - exit_tty_isr_read       ,
-exit_chdev_server_read  , exit_chdev_server_read  - exit_tty_cmd_read       ,
-exit_chdev_cmd_read     , exit_chdev_cmd_read     - exit_chdev_server_read  ,
-exit_txt_read           , exit_txt_read           - exit_chdev_cmd_read     ,
-exit_devfs_read         , exit_devfs_read         - exit_txt_read           ,
-exit_sys_read           , exit_sys_read           - exit_devfs_read         );
-#endif
- 
-	return nbytes;
-
-}  // end sys_read()
+	}
+   
+	return err;
+}
Index: trunk/kernel/syscalls/sys_readdir.c
===================================================================
--- trunk/kernel/syscalls/sys_readdir.c	(revision 690)
+++ trunk/kernel/syscalls/sys_readdir.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_readdir.c - Copy one entry from an open VFS directory to an user buffer.
+ * sys_read.c: read entries from an opened directory
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Author    Alain Greiner (2016,2017,2018,2019,2020)
+ * This file is part of ALMOS-kernel.
  *
- * Copyright (c) UPMC Sorbonne Universites
- *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,125 +17,42 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
-#include <hal_uspace.h>
-#include <hal_vmm.h>
-#include <errno.h>
+#include <vfs.h>
+#include <sys-vfs.h>
+#include <task.h>
 #include <thread.h>
-#include <printk.h>
-#include <vfs.h>
-#include <process.h>
-#include <user_dir.h>
-#include <syscalls.h>
-#include <shared_syscalls.h>
 
-///////////////////////////////////////
-int sys_readdir( DIR            * dirp,
-                 struct dirent ** buffer )
+/* FIXEME: reading dirent from user without any protection */
+
+int sys_readdir (uint_t fd, struct vfs_usp_dirent_s *dirent)
 {
-    error_t         error;
-    vseg_t        * vseg;               // for user space checking of buffer
-    xptr_t          dir_xp;             // extended pointer on user_dir structure
-    user_dir_t    * dir_ptr;            // local pointer on user_dir structure
-    cxy_t           dir_cxy;            // user_dir stucture cluster identifier
-    struct dirent * direntp;            // dirent pointer in user space  
-    uint32_t        entries;            // total number of dirent entries
-    uint32_t        current;            // current dirent index
+	error_t err;
+	struct ku_obj dir;
+	struct task_s *task;
+	struct thread_s *this;
+	struct vfs_file_s *file;
+  
+	file = NULL;
+	task = current_task;
+	this = current_thread;
 
-	thread_t  * this    = CURRENT_THREAD;  // client thread
-	process_t * process = this->process;   // client process
+	if((dirent == NULL)                || 
+	   (fd >= CONFIG_TASK_FILE_MAX_NR) || 
+	   (task_fd_lookup(task, fd, &file)))
+	{
+		this->info.errno = EBADFD;
+		return -1;
+	}
 
-#if (DEBUG_SYS_READDIR || DEBUG_SYSCALLS_ERROR || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_start = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_READDIR
-if( DEBUG_SYS_READDIR < tm_start )
-printk("\n[%s] thread[%x,%x] enter / dirp %x / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, dirp, (uint32_t)tm_start );
-#endif
- 
-    // check dirent buffer in user space
-    error = vmm_get_vseg( process , (intptr_t)buffer, &vseg );
-
-	if( error )
+	KU_OBJ(dir, dirent);
+	if((err = vfs_readdir(file, &dir)))
 	{
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / dirent user buffer %x unmapped\n",
-__FUNCTION__ , process->pid , this->trdid, buffer );
-#endif
-		this->errno = EINVAL;
+		this->info.errno = (err < 0) ? -err : err; 
 		return -1;
-	}	
-
-    // get pointers on user_dir structure from dirp
-    dir_xp  = user_dir_from_ident( (intptr_t)dirp );
-    dir_ptr = GET_PTR( dir_xp );
-    dir_cxy = GET_CXY( dir_xp );
-
-    if( dir_xp == XPTR_NULL )
-	{
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / dirp %x not registered\n",
-__FUNCTION__ , process->pid , this->trdid, dirp );
-#endif
-		this->errno = EBADF;
-		return -1;
-	}	
-
-    // get "current" and "entries_nr" values from user_dir_t structure
-    current = hal_remote_l32( XPTR( dir_cxy , &dir_ptr->current ) );
-    entries = hal_remote_l32( XPTR( dir_cxy , &dir_ptr->entries ) );
-
-    // check "current" index
-    if( current >= entries )
-    {
-        this->errno = 0;
-        return -1;
-    }
-
-    // compute dirent pointer in user space
-    direntp = (struct dirent *)dirp + current;
-
-#if (DEBUG_SYS_READDIR & 1)
-if( DEBUG_SYS_READDIR < (uint32_t)tm_start )
-printk("\n[%s] entries = %d / current = %d / direntp = %x\n",
-__FUNCTION__, entries, current, direntp );
-#endif
-
-    // copy dirent pointer to user buffer 
-    hal_copy_to_uspace( buffer,
-                        XPTR( local_cxy , &direntp ),
-                        sizeof(void *) );
-
-    // update current index in user_dir structure
-    hal_remote_atomic_add( XPTR( dir_cxy , &dir_ptr->current ) , 1 );
-
-    hal_fence();
-
-#if (DEBUG_SYS_READDIR || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_READDIR
-if( DEBUG_SYS_READDIR < (uint32_t)tm_end )
-printk("\n[%s] thread[%x,%x] exit / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, (uint32_t)tm_end );
-#endif
- 
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_READDIR] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_READDIR] , 1 );
-#endif
-
+	}
+   
 	return 0;
-
-}  // end sys_readdir()
+}
Index: trunk/kernel/syscalls/sys_rmdir.c
===================================================================
--- trunk/kernel/syscalls/sys_rmdir.c	(revision 690)
+++ trunk/kernel/syscalls/sys_rmdir.c	(revision 1)
@@ -1,16 +1,14 @@
 /*
- * sys_rmdir.c - Remove a directory from file system.
- *
- * Author    Alain Greiner (2016,2017,2018,2019)
+ * sys_rmdir: remove a directory
  *
  * Copyright (c) 2015 UPMC Sorbonne Universites
  *
- * This file is part of ALMOS-MKH.
+ * This file is part of ALMOS-kernel.
  *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,66 +16,42 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <hal_kernel_types.h>
-#include <hal_uspace.h>
-#include <printk.h>
-#include <errno.h>
+#include <cpu.h>
 #include <vfs.h>
-#include <vmm.h>
+#include <sys-vfs.h>
 #include <thread.h>
-#include <process.h>
+#include <task.h>
 
-#include <syscalls.h>
 
-////////////////////////////////
-int sys_rmdir( char * pathname )
+int sys_rmdir (char *pathname)
 {
-    // error_t     error;
-    char        kbuf[CONFIG_VFS_MAX_PATH_LENGTH];
+	register struct thread_s *this;
+	register struct task_s *task;
+	struct ku_obj ku_path;
+	error_t err = 0;
 	
-	thread_t  * this    = CURRENT_THREAD;
-	process_t * process = this->process;
+	this = current_thread;
+	task = current_task;
 
-#if (DEBUG_SYS_RMDIR || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_start = hal_get_cycles();
-#endif
+	if(!pathname)
+	{
+		this->info.errno = EINVAL;
+		return -1;
+	}
 
-    // check pathname length
-    if( hal_strlen_from_uspace( pathname ) >= CONFIG_VFS_MAX_PATH_LENGTH )
-    {
+	KU_BUFF(ku_path, pathname);
+	rwlock_wrlock(&task->cwd_lock);
 
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : pathname too long\n", __FUNCTION__ );
-#endif
-        this->errno = ENFILE;
-        return -1;
-    }
-
-    // copy pathname in kernel space
-    hal_strcpy_from_uspace( XPTR( local_cxy , kbuf ),
-                            pathname,
-                            CONFIG_VFS_MAX_PATH_LENGTH );
-
-    // get cluster and local pointer on reference process
-    xptr_t      ref_xp  = process->ref_xp;
-    process_t * ref_ptr = (process_t *)GET_PTR( ref_xp );
-    cxy_t       ref_cxy = GET_CXY( ref_xp );
-
-    // get extended pointer on cwd inode
-    // xptr_t cwd_xp = hal_remote_l64( XPTR( ref_cxy , &ref_ptr->vfs_cwd_xp ) );
-   
-    // get the cwd lock in write mode from reference process
-	remote_rwlock_wr_acquire( XPTR( ref_cxy , &ref_ptr->cwd_lock ) );
-
-    // call the relevant VFS function
-	printk("\n[ERROR] in %s : non implemented yet\n", __FUNCTION__ );
-
-    // release the cwd lock
-	remote_rwlock_wr_release( XPTR( ref_cxy , &ref_ptr->cwd_lock ) );
-
+	if((err = vfs_rmdir(&current_task->vfs_cwd, &ku_path)))
+	{
+		current_thread->info.errno = (err < 0) ? -err : err;
+		rwlock_unlock(&task->cwd_lock); 
+		return -1;
+	}
+	
+	rwlock_unlock(&task->cwd_lock); 
 	return 0;
-
-}  // end sys_rmdir()
+}
Index: trunk/kernel/syscalls/sys_rwlock.c
===================================================================
--- trunk/kernel/syscalls/sys_rwlock.c	(revision 1)
+++ trunk/kernel/syscalls/sys_rwlock.c	(revision 1)
@@ -0,0 +1,141 @@
+/*
+ * kern/sys_rwlock.c - interface to access Read-Write locks service
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <types.h>
+#include <errno.h>
+#include <thread.h>
+#include <kmem.h>
+#include <task.h>
+#include <vmm.h>
+#include <kmagics.h>
+#include <rwlock.h>
+
+
+static inline bool_t isBadLock(struct rwlock_s *rwlock)
+{ 
+	return vmm_check_object(rwlock, struct rwlock_s, RWLOCK_ID);
+}
+
+int sys_rwlock(struct rwlock_s **rwlock, uint_t operation)
+{
+	kmem_req_t req;
+	struct rwlock_s *irwlock;
+	error_t err;
+  
+	err = vmm_check_address("usr rwlock ptr", 
+				current_task, 
+				rwlock,
+				sizeof(struct rwlock_s*));
+	if(err)
+		goto SYS_RWLOCK_END;
+
+	if((err = cpu_copy_from_uspace(&irwlock, rwlock, sizeof(struct rwlock_s *))))
+		goto SYS_RWLOCK_END;
+  
+	switch(operation)
+	{    
+	case RWLOCK_INIT:    
+		req.type  = KMEM_RWLOCK;
+		req.size  = sizeof(*irwlock);
+		req.flags = AF_USER;
+
+		if((irwlock = kmem_alloc(&req)) == NULL)
+		{
+			err = ENOMEM;
+			break;
+		}
+    
+		if((err = rwlock_init(irwlock)))
+			break;
+    
+		if((err = cpu_copy_to_uspace(rwlock, &irwlock, sizeof(struct rwlock_s *))))
+		{
+			req.ptr = irwlock;
+			kmem_free(&req);
+		}
+		break;
+
+	case RWLOCK_WRLOCK:
+		if(isBadLock(irwlock))
+			break;
+    
+		return rwlock_wrlock(irwlock);
+
+	case RWLOCK_RDLOCK:
+		if(isBadLock(irwlock))
+			break;
+    
+		return rwlock_rdlock(irwlock);
+
+	case RWLOCK_TRYWRLOCK:
+		if(isBadLock(irwlock))
+			break;
+    
+		return rwlock_trywrlock(irwlock);
+
+	case RWLOCK_TRYRDLOCK:
+		if(isBadLock(irwlock))
+			break;
+    
+		return rwlock_tryrdlock(irwlock);
+
+	case RWLOCK_UNLOCK:
+		if(isBadLock(irwlock))
+			break;
+    
+		if((err = rwlock_unlock(irwlock)))
+			break;
+
+	case RWLOCK_DESTROY:
+		if(isBadLock(irwlock))
+			break;
+    
+		if((err = rwlock_destroy(irwlock)))
+			break;
+
+		req.type = KMEM_RWLOCK;
+		req.ptr  = irwlock;
+		kmem_free(&req);
+		return 0;
+
+	default:
+		err = EINVAL;
+	}
+
+SYS_RWLOCK_END:
+	current_thread->info.errno = err;
+	return err;
+}
+
+KMEM_OBJATTR_INIT(rwlock_kmem_init)
+{
+	attr->type   = KMEM_RWLOCK;
+	attr->name   = "KCM RWLOCK";
+	attr->size   = sizeof(struct rwlock_s);
+	attr->aligne = 0;
+	attr->min    = CONFIG_RWLOCK_MIN;
+	attr->max    = CONFIG_RWLOCK_MAX;
+	attr->ctor   = NULL;
+	attr->dtor   = NULL;
+  
+	return 0;
+}
